// OptDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OptTest.h"
#include "OptDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptTestDlg dialog

COptTestDlg::COptTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COptTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COptTestDlg, CDialog)
	//{{AFX_MSG_MAP(COptTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_B_GET_CHECK, OnBGetCheck)
	ON_BN_CLICKED(IDC_B_SET_CHECK, OnBSetCheck)
	ON_BN_CLICKED(IDC_B_GET_CHECKED_RADIO_BUTTON, OnBGetCheckedRadioButton)
	ON_BN_CLICKED(IDC_B_CHECK_RADIO_BUTTON, OnBCheckRadioButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptTestDlg message handlers

BOOL COptTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_xOptTree.SubclassDlgItem(IDC_TREE1, this);
	m_pimagelist = new CImageList();
	m_pimagelist->Create(16, 16, TRUE/*bMask*/, 6, 4);

	CBitmap bitmap;
	bitmap.LoadBitmap(IDB_B_CHECK0);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();
	
	bitmap.LoadBitmap(IDB_B_CHECK1);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();
	
	bitmap.LoadBitmap(IDB_B_RADIO0);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();
	
	bitmap.LoadBitmap(IDB_B_RADIO1);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();
	
	bitmap.LoadBitmap(IDB_B_CHECK_SECURITY);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();
	
	bitmap.LoadBitmap(IDB_B_RADIO_COOKIE);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();

	bitmap.LoadBitmap(IDB_B_RADIO_SEARCH);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();

	bitmap.LoadBitmap(IDB_B_URL_SEARCH);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();

	bitmap.LoadBitmap(IDB_B_PRINT);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();

	bitmap.LoadBitmap(IDB_B_TOOLS);
	m_pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();

	m_xOptTree.SetImageList(m_pimagelist, TVSIL_NORMAL);

	HTREEITEM  hGroupSecurity = m_xOptTree.AddGroup("Security", 4);
	m_xOptTree.AddCheckBox(1000, "Check Box 1000", hGroupSecurity);
	m_xOptTree.AddCheckBox(1001, "Check Box 1001", hGroupSecurity, TRUE);
	m_xOptTree.AddCheckBox(1002, "Check Box 1002", hGroupSecurity, TRUE);

	HTREEITEM  hGroupCookie = m_xOptTree.AddGroup("Cookie", 5, hGroupSecurity);
	m_xOptTree.AddRadioButton(1003, "Radio button 1003", hGroupCookie);
	m_xOptTree.AddRadioButton(1004, "Radio button 1004 (Default)", hGroupCookie, TRUE);
	m_xOptTree.AddRadioButton(1005, "Radio button 1005", hGroupCookie);

	HTREEITEM  hGroupSearch = m_xOptTree.AddGroup("Search", 6);
	HTREEITEM  hGroupSearchURL = m_xOptTree.AddGroup("Search when URL fails", 7, hGroupSearch);
	m_xOptTree.AddRadioButton(1006, "Radio button 1006", hGroupSearchURL);
	m_xOptTree.AddRadioButton(1007, "Radio button 1007", hGroupSearchURL);
	m_xOptTree.AddRadioButton(1008, "Radio button 1008", hGroupSearchURL);
	m_xOptTree.AddRadioButton(1009, "Radio button 1009 (Default)", hGroupSearchURL, TRUE);
	m_xOptTree.AddCheckBox(1010, "Check Box 1010", hGroupSearch, TRUE);
	m_xOptTree.AddCheckBox(1011, "Check Box 1011", hGroupSearch);
	
	HTREEITEM  hGroupPrint = m_xOptTree.AddGroup("Print", 8, NULL, FALSE);
	m_xOptTree.AddCheckBox(1012, "Check Box 1012", hGroupPrint);
	m_xOptTree.AddCheckBox(1013, "Check Box 1013", hGroupPrint, TRUE);

	HTREEITEM  hGroupTools = m_xOptTree.AddGroup("Tools", 9);
	m_xOptTree.AddCheckBox(1014, "Check Box 1014", hGroupTools);
	m_xOptTree.AddCheckBox(1015, "Check Box 1015", hGroupTools);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COptTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR COptTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COptTestDlg::OnBGetCheck() 
{
	int nCheckButton;
	UINT uID = GetDlgItemInt(IDC_E_ID, NULL, FALSE);
	if (m_xOptTree.GetCheck(uID))
	{
		nCheckButton = IDC_RADIO_ON;
	}
	else
	{
		nCheckButton = IDC_RADIO_OFF;
	}
	CheckRadioButton(IDC_RADIO_ON, IDC_RADIO_OFF, nCheckButton);
}

void COptTestDlg::OnBSetCheck() 
{
	int nCheck;
	UINT uID = GetDlgItemInt(IDC_E_ID, NULL, FALSE);
	if (IDC_RADIO_ON == GetCheckedRadioButton(IDC_RADIO_ON, IDC_RADIO_OFF))
	{
		nCheck = 1;
	}
	else
	{
		nCheck = 0;
	}
	m_xOptTree.SetCheck(uID, nCheck);
}

void COptTestDlg::OnBGetCheckedRadioButton() 
{
	UINT uIDFirst = GetDlgItemInt(IDC_E_FIRST, NULL, FALSE);
	UINT uIDLast = GetDlgItemInt(IDC_E_LAST, NULL, FALSE);

	UINT uIDCheck = m_xOptTree.GetCheckedRadioButton(uIDFirst, uIDLast);
	SetDlgItemInt(IDC_E_CHECK, uIDCheck, FALSE);
}

void COptTestDlg::OnBCheckRadioButton() 
{
	UINT uIDFirst = GetDlgItemInt(IDC_E_FIRST, NULL, FALSE);
	UINT uIDLast = GetDlgItemInt(IDC_E_LAST, NULL, FALSE);
	UINT uIDCheck = GetDlgItemInt(IDC_E_CHECK, NULL, FALSE);

	m_xOptTree.CheckRadioButton(uIDFirst, uIDLast, uIDCheck);
}
