#if !defined _OPTTREE_H_
#define _OPTTREE_H_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// OptTree.h : header file
//

#include <afxtempl.h>
typedef CMap<UINT, UINT, void*, void*> CMapUINTToHTREEITEM;

////////////////////////////////////////////////////////////////
// COptionsTree window

class COptionsTree : public CTreeCtrl
{
// Construction
public:
    COptionsTree();

// Attributes
public:

// Operations
public:
    HTREEITEM AddGroup(LPCSTR pszText, int nImageIndex,
                HTREEITEM hParent=NULL, BOOL bExpanded=TRUE);

    BOOL AddCheckBox(UINT uID, LPCSTR pszText,
                HTREEITEM hParent, BOOL bChecked=FALSE);
    BOOL AddRadioButton(UINT uID, LPCSTR pszText,
                HTREEITEM hParent, BOOL bSelected=FALSE);

    HTREEITEM GetItemFromID(UINT uID);
    UINT GetIDFromItem(HTREEITEM hItemFrom);

    void SetCheck(UINT uID, int nCheck);
    int GetCheck(UINT uID);

    UINT GetCheckedRadioButton(UINT nIDFirstButton,
                    UINT nIDLastButton);
    void CheckRadioButton(UINT nIDFirstButton,
                    UINT nIDLastButton, UINT nIDCheckButton );

// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(COptionsTree)
    //}}AFX_VIRTUAL

// Implementation
public:
    virtual ~COptionsTree();

    // Generated message map functions
protected:
    //{{AFX_MSG(COptionsTree)
    afx_msg void OnClick(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnKeydown(NMHDR* pNMHDR, LRESULT* pResult);
    //}}AFX_MSG

    void ToggleItem(HTREEITEM hItem);
    HTREEITEM GetClickedItem();
    BOOL IsPtOnItem(HTREEITEM hItem, const CPoint& pt);
    BOOL AddItem(UINT uID, LPTV_INSERTSTRUCT ptvs);

    void SetCheck(HTREEITEM hItem, int nCheck);
    int GetCheck(HTREEITEM hItem);
    BOOL IsCheckBox(HTREEITEM hItem);
    BOOL IsRadioButton(HTREEITEM hItem);

    void SetCheckBox(HTREEITEM hItem, int nCheck);
    void SetRadioButton(HTREEITEM hItem, int nCheck);

    int m_nCheck0;
    int m_nCheck1;
    int m_nRadio0;
    int m_nRadio1;
    CMapUINTToHTREEITEM m_muhItems;

    DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional
// declarations immediately before the previous line.

#endif // !defined(_OPTTREE_H_)
